/**
 * @license jquery.panzoom.js v1.12.4
 * Updated: Thu Mar 13 2014
 * Add pan and zoom functionality to any element
 * Copyright (c) 2014 timmy willison
 * Released under the MIT license
 * https://github.com/timmywil/jquery.panzoom/blob/master/MIT-License.txt
 */
!function(a,b){"function"==typeof define&&define.amd?define(["jquery"],b):b("object"==typeof exports?require("jquery"):a.jQuery)}(this,function(a){"use strict";function b(a,b){for(var c=a.length;--c;)if(+a[c]!==+b[c])return!1;return!0}function c(b){var c={range:!0,animate:!0};return"boolean"==typeof b?c.animate=b:a.extend(c,b),c}function d(b,c,d,e,f,g,h,i,j){this.elements="array"===a.type(b)?[+b[0],+b[2],+b[4],+b[1],+b[3],+b[5],0,0,1]:[b,c,d,e,f,g,h||0,i||0,j||1]}function e(a,b,c){this.elements=[a,b,c]}function f(b,c){if(!(this instanceof f))return new f(b,c);1!==b.nodeType&&a.error("Panzoom called on non-Element node"),a.contains(document,b)||a.error("Panzoom element must be attached to the document");var d=a.data(b,k);if(d)return d;this.options=c=a.extend({},f.defaults,c),this.elem=b;var e=this.$elem=a(b);this.$set=c.$set&&c.$set.length?c.$set:e,this.$doc=a(b.ownerDocument||document),this.$parent=e.parent(),this.isSVG=o.test(b.namespaceURI)&&"svg"!==b.nodeName.toLowerCase(),this.panning=!1,this._buildTransform(),this.isSVG||(this._transform=a.cssProps.transform.replace(n,"-$1").toLowerCase()),this._buildTransition(),this.resetDimensions();var g=a(),h=this;a.each(["$zoomIn","$zoomOut","$zoomRange","$reset"],function(a,b){h[b]=c[b]||g}),this.enable(),a.data(b,k,this)}var g="over out down up move enter leave cancel".split(" "),h=a.extend({},a.event.mouseHooks),i={};if(window.PointerEvent)a.each(g,function(b,c){a.event.fixHooks[i[c]="pointer"+c]=h});else{var j=h.props;h.props=j.concat(["touches","changedTouches","targetTouches","altKey","ctrlKey","metaKey","shiftKey"]),h.filter=function(a,b){var c,d=j.length;if(!b.pageX&&b.touches&&(c=b.touches[0]))for(;d--;)a[j[d]]=c[j[d]];return a},a.each(g,function(b,c){if(2>b)i[c]="mouse"+c;else{var d="touch"+("down"===c?"start":"up"===c?"end":c);a.event.fixHooks[d]=h,i[c]=d+" mouse"+c}})}a.pointertouch=i;var k="__pz__",l=Array.prototype.slice,m=!!window.PointerEvent,n=/([A-Z])/g,o=/^http:[\w\.\/]+svg$/,p=/^inline/,q="(\\-?[\\d\\.e]+)",r="\\,?\\s*",s=new RegExp("^matrix\\("+q+r+q+r+q+r+q+r+q+r+q+"\\)$");return d.prototype={x:function(a){var b=a instanceof e,c=this.elements,f=a.elements;return b&&3===f.length?new e(c[0]*f[0]+c[1]*f[1]+c[2]*f[2],c[3]*f[0]+c[4]*f[1]+c[5]*f[2],c[6]*f[0]+c[7]*f[1]+c[8]*f[2]):f.length===c.length?new d(c[0]*f[0]+c[1]*f[3]+c[2]*f[6],c[0]*f[1]+c[1]*f[4]+c[2]*f[7],c[0]*f[2]+c[1]*f[5]+c[2]*f[8],c[3]*f[0]+c[4]*f[3]+c[5]*f[6],c[3]*f[1]+c[4]*f[4]+c[5]*f[7],c[3]*f[2]+c[4]*f[5]+c[5]*f[8],c[6]*f[0]+c[7]*f[3]+c[8]*f[6],c[6]*f[1]+c[7]*f[4]+c[8]*f[7],c[6]*f[2]+c[7]*f[5]+c[8]*f[8]):!1},inverse:function(){var a=1/this.determinant(),b=this.elements;return new d(a*(b[8]*b[4]-b[7]*b[5]),a*-(b[8]*b[1]-b[7]*b[2]),a*(b[5]*b[1]-b[4]*b[2]),a*-(b[8]*b[3]-b[6]*b[5]),a*(b[8]*b[0]-b[6]*b[2]),a*-(b[5]*b[0]-b[3]*b[2]),a*(b[7]*b[3]-b[6]*b[4]),a*-(b[7]*b[0]-b[6]*b[1]),a*(b[4]*b[0]-b[3]*b[1]))},determinant:function(){var a=this.elements;return a[0]*(a[8]*a[4]-a[7]*a[5])-a[3]*(a[8]*a[1]-a[7]*a[2])+a[6]*(a[5]*a[1]-a[4]*a[2])}},e.prototype.e=d.prototype.e=function(a){return this.elements[a]},f.rmatrix=s,f.events=a.pointertouch,f.defaults={eventNamespace:".panzoom",transition:!0,cursor:"move",disablePan:!1,disableZoom:!1,increment:.3,minScale:.4,maxScale:5,rangeStep:.05,duration:200,easing:"ease-in-out",contain:!1},f.prototype={constructor:f,instance:function(){return this},enable:function(){this._initStyle(),this._bind(),this.disabled=!1},disable:function(){this.disabled=!0,this._resetStyle(),this._unbind()},isDisabled:function(){return this.disabled},destroy:function(){this.disable(),a.removeData(this.elem,k)},resetDimensions:function(){var b=this.$parent;this.container={width:b.width(),height:b.height()};var c=this.elem,d=this.$elem,e=this.dimensions=this.isSVG?{left:c.getAttribute("x")||0,top:c.getAttribute("y")||0,width:c.getAttribute("width")||d.outerWidth(),height:c.getAttribute("height")||d.outerHeight(),margin:{left:0,top:0}}:{left:a.css(c,"left",!0)||0,top:a.css(c,"top",!0)||0,width:d.outerWidth(),height:d.outerHeight(),margin:{top:a.css(c,"marginTop",!0)||0,left:a.css(c,"marginLeft",!0)||0}};e.widthBorder=a.css(c,"borderLeftWidth",!0)+a.css(c,"borderRightWidth",!0)||0,e.heightBorder=a.css(c,"borderTopWidth",!0)+a.css(c,"borderBottomWidth",!0)||0},reset:function(a){a=c(a);var b=this.setMatrix(this._origTransform,a);a.silent||this._trigger("reset",b)},resetZoom:function(a){a=c(a);var b=this.getMatrix(this._origTransform);a.dValue=b[3],this.zoom(b[0],a)},resetPan:function(a){var b=this.getMatrix(this._origTransform);this.pan(b[4],b[5],c(a))},setTransform:function(b){for(var c=this.isSVG?"attr":"style",d=this.$set,e=d.length;e--;)a[c](d[e],"transform",b)},getTransform:function(b){var c=this.$set[0];return b?this.setTransform(b):b=a[this.isSVG?"attr":"style"](c,"transform"),"none"===b||s.test(b)||this.isSVG||this.setTransform(b=a.css(c,"transform")),b||"none"},getMatrix:function(a){var b=s.exec(a||this.getTransform());return b&&b.shift(),b||[1,0,0,1,0,0]},setMatrix:function(b,c){if(!this.disabled){c||(c={}),"string"==typeof b&&(b=this.getMatrix(b));var d,e,f,g,h,i,j,k,l=+b[0],m=this.$parent,n="undefined"!=typeof c.contain?c.contain:this.options.contain;return n&&(d=this._checkDims(),e=this.container,f=(d.width*Math.abs(l)-e.width)/2,g=(d.height*Math.abs(l)-e.height)/2,j=d.left+d.margin.left,k=d.top+d.margin.top,"invert"===n?(h=d.width>e.width?d.width-e.width:0,i=d.height>e.height?d.height-e.height:0,f+=(e.width-d.width)/2,g+=(e.height-d.height)/2,b[4]=Math.max(Math.min(b[4],f-j),-f-j-h),b[5]=Math.max(Math.min(b[5],g-k),-g-k-i+d.heightBorder)):(i=e.height>d.height?e.height-d.height:0,"center"===m.css("textAlign")&&p.test(a.css(this.elem,"display"))?h=0:(h=e.width>d.width?e.width-d.width:0,f=g=0),b[4]=Math.min(Math.max(b[4],f-j),-f-j+h),b[5]=Math.min(Math.max(b[5],g-k),-g-k+i))),"skip"!==c.animate&&this.transition(!c.animate),c.range&&this.$zoomRange.val(l),this.setTransform("matrix("+b.join(",")+")"),c.silent||this._trigger("change",b),b}},isPanning:function(){return this.panning},transition:function(b){for(var c=b||!this.options.transition?"none":this._transition,d=this.$set,e=d.length;e--;)a.style(d[e],"transition")!==c&&a.style(d[e],"transition",c)},pan:function(a,b,c){if(!this.options.disablePan){c||(c={});var d=c.matrix;d||(d=this.getMatrix()),c.relative&&(a+=+d[4],b+=+d[5]),d[4]=a,d[5]=b,this.setMatrix(d,c),c.silent||this._trigger("pan",d[4],d[5])}},zoom:function(b,c){"object"==typeof b?(c=b,b=null):c||(c={});var f=a.extend({},this.options,c);if(!f.disableZoom){var g=!1,h=f.matrix||this.getMatrix();"number"!=typeof b&&(b=+h[0]+f.increment*(b?-1:1),g=!0),b>f.maxScale?b=f.maxScale:b<f.minScale&&(b=f.minScale);var i=f.focal;if(i&&!f.disablePan){g=!1;var j=this._checkDims(),k=i.clientX-j.width/2,l=i.clientY-j.height/2,m=new e(k,l,1),n=new d(h),o=this.$parent.offset(),p=new d(1,0,o.left-this.$doc.scrollLeft(),0,1,o.top-this.$doc.scrollTop()),q=n.inverse().x(p.inverse().x(m)),r=b/h[0];n=n.x(new d([r,0,0,r,0,0])),m=p.x(n.x(q)),h[4]=+h[4]+(k-m.e(0)),h[5]=+h[5]+(l-m.e(1))}h[0]=b,h[3]="number"==typeof f.dValue?f.dValue:b,this.setMatrix(h,{animate:"boolean"==typeof f.animate?f.animate:g,range:!f.noSetRange}),f.silent||this._trigger("zoom",h[0],f)}},option:function(b,c){var d;if(!b)return a.extend({},this.options);if("string"==typeof b){if(1===arguments.length)return void 0!==this.options[b]?this.options[b]:null;d={},d[b]=c}else d=b;this._setOptions(d)},_setOptions:function(b){a.each(b,a.proxy(function(b,c){switch(b){case"disablePan":this._resetStyle();case"$zoomIn":case"$zoomOut":case"$zoomRange":case"$reset":case"disableZoom":case"onStart":case"onChange":case"onZoom":case"onPan":case"onEnd":case"onReset":case"eventNamespace":this._unbind()}switch(this.options[b]=c,b){case"disablePan":this._initStyle();case"$zoomIn":case"$zoomOut":case"$zoomRange":case"$reset":this[b]=c;case"disableZoom":case"onStart":case"onChange":case"onZoom":case"onPan":case"onEnd":case"onReset":case"eventNamespace":this._bind();break;case"cursor":a.style(this.elem,"cursor",c);break;case"minScale":this.$zoomRange.attr("min",c);break;case"maxScale":this.$zoomRange.attr("max",c);break;case"rangeStep":this.$zoomRange.attr("step",c);break;case"startTransform":this._buildTransform();break;case"duration":case"easing":this._buildTransition();case"transition":this.transition();break;case"$set":c instanceof a&&c.length&&(this.$set=c)}},this))},_initStyle:function(){this.options.disablePan||this.$elem.css("cursor",this.options.cursor);var b=this.$parent;if(b.length&&!a.nodeName(b[0],"body")){var c={overflow:"hidden"};"static"===b.css("position")&&(c.position="relative"),b.css(c)}},_resetStyle:function(){this.$elem.css({cursor:"",transition:""}),this.$parent.css({overflow:"",position:""})},_bind:function(){var b=this,c=this.options,d=c.eventNamespace,e=m?"pointerdown"+d:"touchstart"+d+" mousedown"+d,g=m?"pointerup"+d:"touchend"+d+" click"+d,h={},i=this.$reset,j=this.$zoomRange;if(a.each(["Start","Change","Zoom","Pan","End","Reset"],function(){var b=c["on"+this];a.isFunction(b)&&(h["panzoom"+this.toLowerCase()+d]=b)}),c.disablePan&&c.disableZoom||(h[e]=function(a){var d;("touchstart"===a.type?!(d=a.touches)||(1!==d.length||c.disablePan)&&2!==d.length:c.disablePan||1!==a.which)||(a.preventDefault(),a.stopPropagation(),b._startMove(a,d))}),this.$elem.on(h),i.length&&i.on(g,function(a){a.preventDefault(),b.reset()}),j.length&&j.attr({step:c.rangeStep===f.defaults.rangeStep&&j.attr("step")||c.rangeStep,min:c.minScale,max:c.maxScale}).prop({value:this.getMatrix()[0]}),!c.disableZoom){var k=this.$zoomIn,l=this.$zoomOut;k.length&&l.length&&(k.on(g,function(a){a.preventDefault(),b.zoom()}),l.on(g,function(a){a.preventDefault(),b.zoom(!0)})),j.length&&(h={},h[(m?"pointerdown":"mousedown")+d]=function(){b.transition(!0)},h["change"+d]=function(){b.zoom(+this.value,{noSetRange:!0})},j.on(h))}},_unbind:function(){this.$elem.add(this.$zoomIn).add(this.$zoomOut).add(this.$reset).off(this.options.eventNamespace)},_buildTransform:function(){return this._origTransform=this.getTransform(this.options.startTransform)},_buildTransition:function(){var a=this.options;this._transform&&(this._transition=this._transform+" "+a.duration+"ms "+a.easing)},_checkDims:function(){var a=this.dimensions;return(a.width===a.widthBorder||a.height===a.heightBorder)&&this.resetDimensions(),this.dimensions},_getDistance:function(a){var b=a[0],c=a[1];return Math.sqrt(Math.pow(Math.abs(c.clientX-b.clientX),2)+Math.pow(Math.abs(c.clientY-b.clientY),2))},_getMiddle:function(a){var b=a[0],c=a[1];return{clientX:(c.clientX-b.clientX)/2+b.clientX,clientY:(c.clientY-b.clientY)/2+b.clientY}},_trigger:function(a){"string"==typeof a&&(a="panzoom"+a),this.$elem.triggerHandler(a,[this].concat(l.call(arguments,1)))},_startMove:function(c,d){var e,f,g,h,i,j,k,l,n=this,o=this.options,p=o.eventNamespace,q=this.getMatrix(),r=q.slice(0),s=+r[4],t=+r[5],u={matrix:q,animate:"skip"};m?(f="pointermove",g="pointerup"):"touchstart"===c.type?(f="touchmove",g="touchend"):(f="mousemove",g="mouseup"),f+=p,g+=p,this.transition(!0),this.panning=!0,this._trigger("start",c,d),d&&2===d.length?(h=this._getDistance(d),i=+q[0],j=this._getMiddle(d),e=function(a){a.preventDefault();var b=n._getMiddle(d=a.touches),c=n._getDistance(d)-h;n.zoom(c*(o.increment/100)+i,{focal:b,matrix:q}),n.pan(+q[4]+b.clientX-j.clientX,+q[5]+b.clientY-j.clientY,u),j=b}):(k=c.pageX,l=c.pageY,e=function(a){a.preventDefault(),n.pan(s+a.pageX-k,t+a.pageY-l,u)}),a(document).off(p).on(f,e).on(g,function(c){c.preventDefault(),a(this).off(p),n.panning=!1,c.type="panzoomend",n._trigger(c,q,!b(q,r))})}},a.Panzoom=f,a.fn.panzoom=function(b){var c,d,e,g;return"string"==typeof b?(g=[],d=l.call(arguments,1),this.each(function(){c=a.data(this,k),c?"_"!==b.charAt(0)&&"function"==typeof(e=c[b])&&void 0!==(e=e.apply(c,d))&&g.push(e):g.push(void 0)}),g.length?1===g.length?g[0]:g:this):this.each(function(){new f(this,b)})},f});